# Change Log

All notable changes to this project will be documented in this file.
See [Conventional Commits](https://conventionalcommits.org) for commit guidelines.

## [3.0.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-data-provider@2.2.0...@billogram/foundation-data-provider@3.0.0) (2021-01-21)

### Features

* Rework (list) data providers ([77bc5508](https://github.com/billogram/frontend-foundation/commit/77bc5508))
* Implement data prosumer ([c15dbcfd](https://github.com/billogram/frontend-foundation/commit/c15dbcfd))


### BREAKING CHANGES

* There are major breaking changes to
- foundation-data-provider
- foundation-list-data-provider
- foundation-table



## [2.2.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-data-provider@2.1.0...@billogram/foundation-data-provider@2.2.0) (2021-01-10)

### Bug Fixes

* Use arrow functions for useCallback callbacks ([8ee4239e](https://github.com/billogram/frontend-foundation/commit/8ee4239e))
* Prefer React import ([40e8d46a](https://github.com/billogram/frontend-foundation/commit/40e8d46a))
* Fix @typescript-eslint/naming-convention ([c04296e0](https://github.com/billogram/frontend-foundation/commit/c04296e0))
* Fix typescript-eslint/no-non-null-assertion ([2c2740e6](https://github.com/billogram/frontend-foundation/commit/2c2740e6))
* Fix linting in foundation-data-provider ([437f14dd](https://github.com/billogram/frontend-foundation/commit/437f14dd))


### Features

* Upgrade React ([978bf30e](https://github.com/billogram/frontend-foundation/commit/978bf30e))



## [2.1.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-data-provider@2.0.0...@billogram/foundation-data-provider@2.1.0) (2020-06-18)

### Bug Fixes

* Fix potential cannot property of undefined ([7d4bf3d7](https://github.com/billogram/frontend-foundation/commit/7d4bf3d7))
* Fix typing for partially updating data ([cbd8dfe8](https://github.com/billogram/frontend-foundation/commit/cbd8dfe8))


### Features

* Include errors in fetch result ([66211e4d](https://github.com/billogram/frontend-foundation/commit/66211e4d))
* Make it possible to fetch partial data ([c461f5d9](https://github.com/billogram/frontend-foundation/commit/c461f5d9))



## [2.0.0](https://github.com/billogram/frontend-foundation/compare/@billogram/foundation-data-provider@1.0.1...@billogram/foundation-data-provider@2.0.0) (2020-06-17)

### Features

* Add update to data provider ([106049a5](https://github.com/billogram/frontend-foundation/commit/106049a5))
* Rework the FoundationDataProviderContext ([1b5d7896](https://github.com/billogram/frontend-foundation/commit/1b5d7896))


### BREAKING CHANGES

* This completely changes how the
@billogram/foundation-data-provider works.



## [1.0.1](https://github.com/billogram/frontend-foundation/compare/dbf5a8709119374207dd2d28f6ffeffac17d5871...@billogram/foundation-data-provider@1.0.1) (2020-01-20)

### Bug Fixes

* Export props ([06802c25](https://github.com/billogram/frontend-foundation/commit/06802c25))
* Rename button, error, spinner, and textbox packages ([bf794373](https://github.com/billogram/frontend-foundation/commit/bf794373))
* Prefer interface to type alias ([a9343e5b](https://github.com/billogram/frontend-foundation/commit/a9343e5b))
* Use dependencies instead of peer dependencies ([a1cbff4b](https://github.com/billogram/frontend-foundation/commit/a1cbff4b))


### Features

* Add typed contexts ([2c4b571d](https://github.com/billogram/frontend-foundation/commit/2c4b571d))
* Add FoundationDataProviderContext ([c4e37f26](https://github.com/billogram/frontend-foundation/commit/c4e37f26))
* Implement data provider ([87449555](https://github.com/billogram/frontend-foundation/commit/87449555))
* Scaffold out @billogram/foundation-data-provider ([7c88972e](https://github.com/billogram/frontend-foundation/commit/7c88972e))


### BREAKING CHANGES

* Force the first release to start from 1.0.0.



## [1.0.0](https://github.com/billogram/frontend-foundation/compare/dbf5a8709119374207dd2d28f6ffeffac17d5871...@billogram/foundation-data-provider@1.0.0) (2020-01-20)

### Bug Fixes

* Export props ([06802c25](https://github.com/billogram/frontend-foundation/commit/06802c25))
* Rename button, error, spinner, and textbox packages ([bf794373](https://github.com/billogram/frontend-foundation/commit/bf794373))
* Prefer interface to type alias ([a9343e5b](https://github.com/billogram/frontend-foundation/commit/a9343e5b))
* Use dependencies instead of peer dependencies ([a1cbff4b](https://github.com/billogram/frontend-foundation/commit/a1cbff4b))


### Features

* Add typed contexts ([2c4b571d](https://github.com/billogram/frontend-foundation/commit/2c4b571d))
* Add FoundationDataProviderContext ([c4e37f26](https://github.com/billogram/frontend-foundation/commit/c4e37f26))
* Implement data provider ([87449555](https://github.com/billogram/frontend-foundation/commit/87449555))
* Scaffold out @billogram/foundation-data-provider ([7c88972e](https://github.com/billogram/frontend-foundation/commit/7c88972e))


### BREAKING CHANGES

* Force the first release to start from 1.0.0.
