/// <reference types="react" />
export declare type FoundationDataProviderFetchStateInitializing = 'fetching-initial';
export declare type FoundationDataProviderFetchStateInitializingError = 'error-initial';
export declare type FoundationDataProviderFetchStateInitialized = 'fetching' | 'success';
export declare type FoundationDataProviderFetchStateInitializedError = 'error';
export declare type FoundationDataProviderFetchState = FoundationDataProviderFetchStateInitializing | FoundationDataProviderFetchStateInitializingError | FoundationDataProviderFetchStateInitialized | FoundationDataProviderFetchStateInitializedError;
export interface FoundationDataProviderResultInitializing {
    state: FoundationDataProviderFetchStateInitializing;
}
export interface FoundationDataProviderResultInitializingError<TErrors = unknown> {
    errors: TErrors;
    state: FoundationDataProviderFetchStateInitializingError;
}
export interface FoundationDataProviderResultInitialized<TData> {
    data: TData;
    state: FoundationDataProviderFetchStateInitialized;
}
export interface FoundationDataProviderResultInitializedError<TData, TErrors = unknown> {
    data: TData;
    errors: TErrors;
    state: FoundationDataProviderFetchStateInitializedError;
}
export declare type FoundationDataProviderResult<TData, TErrors = unknown> = FoundationDataProviderResultInitializing | FoundationDataProviderResultInitializingError<TErrors> | FoundationDataProviderResultInitialized<TData> | FoundationDataProviderResultInitializedError<TData, TErrors>;
export interface FoundationDataProviderFetchHandler<TOptions = never> {
    (options?: TOptions): Promise<void>;
}
export interface FoundationDataProviderUpdateHandler<TData> {
    (data: Partial<TData>): void;
}
export interface FoundationDataProviderFetch<TData, TOptions = never> {
    (options?: TOptions): Promise<TData>;
}
export interface FoundationDataProviderContextType<TData, TOptions = never> {
    fetch: FoundationDataProviderFetchHandler<TOptions>;
    result: FoundationDataProviderResult<TData>;
    update: FoundationDataProviderUpdateHandler<TData>;
}
export interface FoundationDataProviderProps<TData, TOptions = never> {
    children: React.ReactNode;
    fetchData: FoundationDataProviderFetch<TData, TOptions>;
    initialFetchDataOptions?: TOptions;
}
export interface FoundationDataConsumerProps<TData, TOptions = never> {
    children: (context: FoundationDataProviderContextType<TData, TOptions>) => React.ReactElement | null;
}
export declare type FoundationDataProsumerProps<TData, TOptions = never> = Omit<FoundationDataProviderProps<TData, TOptions>, 'children'> & FoundationDataConsumerProps<TData, TOptions>;
export interface FoundationDataProviderCreateResult<TData, TOptions = never> {
    FoundationDataConsumer: React.ComponentType<FoundationDataConsumerProps<TData, TOptions>>;
    FoundationDataProvider: React.ComponentType<FoundationDataProviderProps<TData, TOptions>>;
    FoundationDataProsumer: React.ComponentType<FoundationDataProsumerProps<TData, TOptions>>;
    useDataProvider: () => FoundationDataProviderContextType<TData, TOptions>;
}
